/*
 * KasirLogin.java
 *
 * Created on July 6, 2005, 10:49 PM
 */

package pos;

import com.ustasoft.component.DBConnection;
import com.ustasoft.component.Konfigurasi;
import com.ustasoft.component.OSValidator;
import com.ustasoft.config.InformasiPerusahaan;
import com.ustasoft.config.KonfigurasiSistemDao;
import com.ustasoft.config.SettingKoneksi;
import com.ustasoft.config.SettingPenjualan;
import java.awt.Color;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.sql.*;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Properties;
import java.util.Timer;
import java.util.TimerTask;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.plaf.BorderUIResource;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.security.crypto.password.PasswordEncoder;

/**
 *
 * @author  super
 */
public class LoginUser extends javax.swing.JFrame {
    //KasirCon conn;
    private Timer timer;
    int i,p,q,iCount=0;
    private String sID,sName,sShift,sIDphoto;
    private boolean sSuper;
    private Connection conn;
    private DefaultListModel lstModel=new DefaultListModel();
    static int authority;
    static String sKota;
    private Object srcForm;
    BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();;
    //SysConfig sc=new SysConfig();

    
    /** Creates new form KasirLogin */
    public LoginUser() {

        BorderUIResource borderUIResource= new BorderUIResource(BorderFactory.createLineBorder(Color.yellow, 2));
            UIManager.put("Table.focusCellHighlightBorder", borderUIResource);
        initComponents();
        setIconImage(new ImageIcon(getClass().getResource("/resources/images/user.png")).getImage());
        txtKasir.addFocusListener(txtFocusListener);
        txtPass.addFocusListener(txtFocusListener);
        Calendar rightNow = Calendar.getInstance();
        int hour = rightNow.get(Calendar.HOUR_OF_DAY);
        if(hour>=14 && hour <24){
            rbShiftSore.setSelected(true);
        }
        
//        jLabel3.setVisible(false);
//        cmbGudang.setVisible(false);

       // this.setState(Frame.ICONIFIED);
    }
    
    public void setObjForm(Object src){
        this.srcForm=src;
    }
    
    private FocusListener txtFocusListener=new FocusListener() {
        public void focusGained(FocusEvent e) {
            if(e.getSource() instanceof JTextField || e.getSource() instanceof JFormattedTextField){
                ((JTextField)e.getSource()).setBackground(Color.YELLOW);
                if( (e.getSource() instanceof JTextField && ((JTextField)e.getSource()).getName()!=null && ((JTextField)e.getSource()).getName().equalsIgnoreCase("textEditor"))){
                    ((JTextField)e.getSource()).setSelectionStart(0);
                    ((JTextField)e.getSource()).setSelectionEnd(((JTextField)e.getSource()).getText().length());

                }
            }
        }


        public void focusLost(FocusEvent e) {
            if(e.getSource() instanceof  JTextField || e.getSource() instanceof  JFormattedTextField || 
                    e.getSource() instanceof JPasswordField){
                ((JTextField)e.getSource()).setBackground(Color.WHITE);
                }
           }
    } ;
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        buttonGroup2 = new javax.swing.ButtonGroup();
        buttonGroup3 = new javax.swing.ButtonGroup();
        panelLogin1 = new com.ustasoft.component.panelLogin();
        btnOK = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        btnCancel = new javax.swing.JButton();
        pBar = new javax.swing.JProgressBar();
        txtPass = new javax.swing.JPasswordField();
        jLabel1 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        txtKasir = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        rbShiftSore = new javax.swing.JRadioButton();
        rbShiftPagi = new javax.swing.JRadioButton();

        jLabel5.setText("jLabel5");

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Login");
        setBackground(new java.awt.Color(204, 153, 0));
        setForeground(new java.awt.Color(204, 153, 0));
        setLocationByPlatform(true);
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.LINE_AXIS));

        panelLogin1.setForeground(new java.awt.Color(255, 255, 51));
        panelLogin1.setLayout(null);

        btnOK.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/accept.png"))); // NOI18N
        btnOK.setText("OK");
        btnOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOKActionPerformed(evt);
            }
        });
        btnOK.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                btnOKKeyPressed(evt);
            }
        });
        panelLogin1.add(btnOK);
        btnOK.setBounds(135, 140, 95, 30);

        jLabel2.setBackground(new java.awt.Color(255, 255, 0));
        jLabel2.setText("    ");
        jLabel2.setOpaque(true);
        panelLogin1.add(jLabel2);
        jLabel2.setBounds(20, 175, 20, 20);

        btnCancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/cancel.png"))); // NOI18N
        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });
        panelLogin1.add(btnCancel);
        btnCancel.setBounds(230, 140, 110, 30);
        panelLogin1.add(pBar);
        pBar.setBounds(20, 175, 320, 20);

        txtPass.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        txtPass.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtPass.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtPassActionPerformed(evt);
            }
        });
        panelLogin1.add(txtPass);
        txtPass.setBounds(205, 90, 140, 20);

        jLabel1.setBackground(new java.awt.Color(255, 255, 0));
        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 51));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel1.setText("User");
        panelLogin1.add(jLabel1);
        jLabel1.setBounds(130, 60, 70, 20);

        jLabel10.setBackground(new java.awt.Color(255, 255, 0));
        jLabel10.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel10.setForeground(new java.awt.Color(255, 255, 51));
        jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel10.setText("Shift");
        panelLogin1.add(jLabel10);
        jLabel10.setBounds(130, 115, 70, 20);

        txtKasir.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        txtKasir.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtKasir.setNextFocusableComponent(txtPass);
        txtKasir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtKasirActionPerformed(evt);
            }
        });
        txtKasir.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtKasirKeyPressed(evt);
            }
        });
        panelLogin1.add(txtKasir);
        txtKasir.setBounds(205, 60, 140, 20);

        jLabel11.setBackground(new java.awt.Color(255, 255, 0));
        jLabel11.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel11.setForeground(new java.awt.Color(255, 255, 51));
        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel11.setText("Password");
        panelLogin1.add(jLabel11);
        jLabel11.setBounds(130, 90, 70, 20);

        buttonGroup1.add(rbShiftSore);
        rbShiftSore.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        rbShiftSore.setForeground(new java.awt.Color(255, 255, 0));
        rbShiftSore.setText("SORE");
        panelLogin1.add(rbShiftSore);
        rbShiftSore.setBounds(270, 115, 70, 18);

        buttonGroup1.add(rbShiftPagi);
        rbShiftPagi.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        rbShiftPagi.setForeground(new java.awt.Color(255, 255, 0));
        rbShiftPagi.setSelected(true);
        rbShiftPagi.setText("PAGI");
        panelLogin1.add(rbShiftPagi);
        rbShiftPagi.setBounds(210, 115, 70, 18);

        getContentPane().add(panelLogin1);

        setSize(new java.awt.Dimension(378, 244));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void txtKasirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtKasirActionPerformed
        txtPass.setRequestFocusEnabled(true);
    }//GEN-LAST:event_txtKasirActionPerformed

    private void txtKasirKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtKasirKeyPressed
        if(evt.getKeyCode()==evt.VK_ENTER){
            txtPass.requestFocusInWindow();
        }
    }//GEN-LAST:event_txtKasirKeyPressed

    private void btnOKKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_btnOKKeyPressed
        btnOKActionPerformed(null);
    }//GEN-LAST:event_btnOKKeyPressed

    private void txtPassActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtPassActionPerformed
        btnOKKeyPressed(null);
    }//GEN-LAST:event_txtPassActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        if(conn==null) {
            conn=new DBConnection(MainForm.sU, MainForm.sP, this).getCon();
        }
        i=pBar.getX();            
        timer = new Timer();
        timer.schedule(new DoTick(), 0,5);
        java.text.SimpleDateFormat fdate2 = new java.text.SimpleDateFormat("HH:mm");
        
       

            //this.getRootPane().setWindowDecorationStyle(JRootPane.FRAME);
            //this.setExtendedState(MAXIMIZED_BOTH);
            
        try{
            Statement st=MainForm.conn.createStatement();
            ResultSet rs=st.executeQuery("select now() sekarang");
            rs.next();
            MainForm.tglSkg = rs.getDate(1);
            Date jamNow = rs.getTime(1); //Calendar.getInstance().getTime();            
            System.out.println("JAM: "+fdate2.format(jamNow.getTime()));
            SimpleDateFormat hh=new SimpleDateFormat("HH:mm");

            KonfigurasiSistemDao konfigurasiSistemDao = new KonfigurasiSistemDao();
            InformasiPerusahaan info = konfigurasiSistemDao.getInformasiPerusahaan();
            
            Konfigurasi.TGL_DEFAULT_SYSTEM = info.isTglSystemDefault();
            Konfigurasi.STATUS_SHIFT = info.isStatusShift();
            
            SettingPenjualan settingPenjualan = konfigurasiSistemDao.getSettingPenjualan();
            Konfigurasi.TUTUP_DIALOG_PEMBAYARAN = settingPenjualan.isTutupDialogBayarPrint();
            Konfigurasi.TAMPILKAN_HPP_PENJUALAN = settingPenjualan.isTampilkanHpp();
            Konfigurasi.JUMLAH_CETAK_FAKTUR_PENJUALAN = settingPenjualan.getJumlahCetakFaktur();
            
            SettingKoneksi settingKoneksi = konfigurasiSistemDao.getSettingKoneksi();
            Konfigurasi.PRINTER_KECIL = settingKoneksi.getPrinterKecil();
            Konfigurasi.PRINTER_BESAR = settingKoneksi.getPrinterBesar();
            Konfigurasi.PRINTER_BARCODE = settingKoneksi.getPrinterBarcode();
            Konfigurasi.PRINTER_BARCODE_PREVIEW = settingKoneksi.isPrinterBarcodePreview();
            
            jLabel10.setVisible(Konfigurasi.STATUS_SHIFT);
            rbShiftPagi.setVisible(Konfigurasi.STATUS_SHIFT);
            rbShiftSore.setVisible(Konfigurasi.STATUS_SHIFT);
            if(!Konfigurasi.STATUS_SHIFT) {
                MainForm.shift = "P";
            }
            setTitle(info.getNamaToko());
        }catch(SQLException se){
            JOptionPane.showMessageDialog(this, se.getMessage());
        }
    }//GEN-LAST:event_formWindowOpened

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        System.exit(0);
    }//GEN-LAST:event_btnCancelActionPerformed

    public void setUserID(String newUser){
        sID=newUser;
    }
    
    public void setUserName(String userName){
        sName=userName;
    }
       
    
    private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOKActionPerformed
//        if(srcForm==null)
            LogMasuk();        
//        else if(srcForm instanceof MainForm){
//            MainForm.sUserName=txtKasir.getText();
//            ((MainForm)srcForm).udfSetUserMenu();
//            this.dispose();
//        }
    }//GEN-LAST:event_btnOKActionPerformed

    private void LogMasuk(){
        //SysConfig sc = new SysConfig();
        String pass ="";
        char chrPass[] = txtPass.getPassword();
        
        for(int i=0; i<chrPass.length; i++){
            pass = pass+chrPass[i];
            chrPass[i]='0';            
        }
       
//        iCount++;
//        if (iCount==3){
//            System.exit(1);
//        }
//        
        
        //conn = new KasirCon("jdbc:postgresql://"+sc.getServerLoc()+":5432/"+sc.getDBName(), txtKasir.getText(), pass, this);
        //conn = new KasirCon("jdbc:postgresql://"+sc.getServerLoc()+":5432/"+sc.getDBName(), "joss", "123", this);
        
        //if (conn.gettErrLog()==true){
        //    con=conn.getCon();
        
        boolean sukses= conn!=null;
        InputStream input = null;
        Properties prop = new Properties();
        
        try{
            ResultSet rs=conn.createStatement().executeQuery("select * from m_user where upper(user_name)='"+txtKasir.getText().toUpperCase()+"' ");
            
            if(rs.next()){
                if(!passwordEncoder.matches(pass, rs.getString("pwd"))){
                    JOptionPane.showMessageDialog(this, "Username/Password yang anda tidak sesuai!");
                    return;
                }
                sukses=true;
                MainForm.sUserId=rs.getString("user_id");
                MainForm.conn = this.conn;
                if(!Konfigurasi.STATUS_SHIFT) {
                    MainForm.shift = "P";
                }else{
                    MainForm.shift=rbShiftPagi.isSelected()? "P": "S";
                }
                input = new FileInputStream("setting.properties");
                prop.load(input);
                Konfigurasi.TAMPILKAN_FAKTUR_SEBELUM_DICETAK = prop.getProperty("tampikan_sebelum_cetak") != null && prop.getProperty("tampikan_sebelum_cetak").equalsIgnoreCase("1");
                Konfigurasi.GUDANG_DEFAULT = prop.getProperty("gudang");
                
                
            }
            else{
                JOptionPane.showMessageDialog(this, "Silakan masukkan nama user & passwod dengan benar!");
                txtKasir.requestFocus();
                txtKasir.setSelectionStart(0);
                txtKasir.setSelectionEnd(txtKasir.getText().length());
                return;
            }
        }catch(SQLException se){
            JOptionPane.showMessageDialog(this, se.getMessage());
            return;
        } catch (FileNotFoundException ex) {
            Logger.getLogger(LoginUser.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(LoginUser.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        
        
//        try{
//            Statement st =con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_READ_ONLY);    
//            //ResultSet rs = st.executeQuery("select usename,usesysid,usesuper from pg_user where usename='"+ txtKasir.getText().trim() +"'");            
//            String sQry="select user_id, pwd, username, coalesce(profile, -1) as profile " +
//                    "from m_user " +
//                    "where username='"+ txtKasir.getText().trim() +"' " +
//                    " ";
//
//            ResultSet rs = st.executeQuery(sQry);
//            System.out.println(sQry);
            if (sukses ){          //&& rs.next()      
                sName=txtKasir.getText(); //rs.getString("username").trim();
                timer.cancel();
                setVisible(false);  
                if(srcForm !=null && srcForm instanceof MainForm) {
                    ((MainForm)srcForm).udfSetUserMenu();
                    ((MainForm)srcForm).setVisible(true);
                }else{
                    MainForm fMain  = new MainForm();
                    fMain.setConn(conn);
                    fMain.sUserName= sName;
                    fMain.setVisible(true);
                }
            }
//        }catch(SQLException se) {
//            JOptionPane.showMessageDialog(this, se.getMessage());
//        }
        
    }

    public void setSrcForm(Object aThis) {
        this.srcForm=aThis;
    }

    void setConn(Connection con) {
        this.conn=con;
    }
    
    
    class DoTick extends TimerTask {
      public void run() {
            if ((i)<=pBar.getWidth() || q==0){                
                p=i;
                i++;
                q=i;
            }else{                
                p=q;
                q--;
                if (q==pBar.getX()){
                    i=pBar.getX();
                }                
            }
            jLabel2.setLocation(p, jLabel2.getY());            
      } 
    }
    private void LabelIcon(String aFile,javax.swing.JLabel newlbl) {              
       javax.swing.ImageIcon myIcon = new javax.swing.ImageIcon(getClass().getResource(aFile));
       newlbl.setIcon(myIcon);
    }
    
    /**
     * @param args the command line arguments
     
    public static void main(String args[]) {
        //java.awt.EventQueue.invokeLater(new Runnable() {
        //     public void run() {                
        //        new KasirLoginOny().setVisible(true);
        //    }
        //});
    }
     * 
     * 
     */
    
    Color g1 = new Color(153,255,255);
    Color g2 = new Color(255,255,255); 
    
    Color fHitam = new Color(0,0,0);
    Color fPutih = new Color(255,255,255); 
    
    Color crtHitam =new java.awt.Color(0, 0, 0);
    Color crtPutih = new java.awt.Color(255, 255, 255); 
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnOK;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.ButtonGroup buttonGroup3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JProgressBar pBar;
    private com.ustasoft.component.panelLogin panelLogin1;
    private javax.swing.JRadioButton rbShiftPagi;
    private javax.swing.JRadioButton rbShiftSore;
    private javax.swing.JTextField txtKasir;
    private javax.swing.JPasswordField txtPass;
    // End of variables declaration//GEN-END:variables
}
